#!BPY

# A script to convert a NURBS Curve into a set of IPO curves which can be used by an object to simulate the path it is flying
# Original script by haramanai of Belnder Artists
# First imptovement by Dr S
# Second improvement by Grogyan with hacks of his own code

# This script should now work from the scripts menu

"""
Name: 'Path 2 IPO'
Blender: 246
Group: 'Wizards'
Tooltip: 'Make IPO curves from NURBS curves'
"""

import Blender

#Bake the animation in a way.

# f1 is the start frame f2 is the end
# change them to suit your needs
f1 = 1

# Get the currently selected object
myCurveOb = Blender.Object.GetSelected()[0]

# Get the data associated with it
myCurveData = Blender.Curve.Get()[0]

# Get the object name of the curve
myCurveName = myCurveOb.getName()
#myCurveBez = Blender.Object.Get(myCurve)	# Get data of curve 
		
# Initialize what will be the name of the IPO's
myIPOCurveSet =  myCurveOb.getName() 

# Get the length of the curve in frames
myPathLength = myCurveData.getPathLen()

#myIPOCurves = myIPOCurves.LOC[x]
#myIPOCurveSet = Blender.Ipo.New('Object', myCurveName) # Attmpting  to get the Curve name same as IPO curve set

#sets the number of frames per ipo keys
step =5

#The selected Object
MyCurveOb = Blender.Object.GetSelected()[0]
#The duplicant
Blender.Object.Duplicate()
MyCurveOb2 = Blender.Object.GetSelected()[0]
MyCurveOb2.clrParent()
MyCurveOb2.clearIpo()

for i in range(f1 , myPathLength , step):
	Blender.Set('curframe' , i)
	MyCurveOb2.setMatrix(MyCurveOb.getMatrix() )
	MyCurveOb2.insertIpoKey(0)
	MyCurveOb2.insertIpoKey(1)